accounts/urls.py
from django.urls import path
from accounts.views import UserLogin, UserLogout, signup

urlpatterns = [
    path("login/", UserLogin.as_view(), name="login"),
    path("logout/", UserLogout.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

expenses/urls.py
from django.contrib import admin
from django.urls import path, include, reverse_lazy
from django.views.generic import RedirectView

urlpatterns = [
    path("admin/", admin.site.urls),
    path("receipts/", include("receipts.urls")),
    path("accounts/", include("accounts.urls")),
    path("", RedirectView.as_view(url=reverse_lazy("home"))),
]

receipts/urls.py
from django.urls import path
from receipts.views import (
    ReceiptListView,
    ReceiptCreateView,
    ExpenseCategoryCreateView,
    ExpenseCategoryListView,
    AccountCreateView,
    AccountListView,
)


urlpatterns = [
    path("", ReceiptListView.as_view(), name="home"),
    path("create/", ReceiptCreateView.as_view(), name="create_receipt"),
    path(
        "categories/create/",
        ExpenseCategoryCreateView.as_view(),
        name="create_category",
    ),
    path(
        "categories/", ExpenseCategoryListView.as_view(), name="category_list"
    ),
    path("accounts/", AccountListView.as_view(), name="account_list"),
    path(
        "accounts/create/", AccountCreateView.as_view(), name="create_account"
    ),
]

accounts/models.py
from django.db import models

# Create your models here.

receipts/models.py
from functools import total_ordering
from django.db import models
from django.conf import settings

# Create your models here.
USER_MODEL = settings.AUTH_USER_MODEL


class Receipt(models.Model):
    vendor = models.CharField(max_length=200)
    total = models.DecimalField(decimal_places=3, max_digits=10)
    tax = models.DecimalField(decimal_places=3, max_digits=10)
    date = models.DateField()
    category = models.ForeignKey(
        "ExpenseCategory", related_name="receipts", on_delete=models.CASCADE
    )
    account = models.ForeignKey(
        "Account",
        related_name="receipts",
        on_delete=models.CASCADE,
        null=True,
    )
    purchaser = models.ForeignKey(
        USER_MODEL,
        related_name="receipts",
        on_delete=models.CASCADE,
    )

    def __str__(self):
        return self.vendor


class ExpenseCategory(models.Model):
    name = models.CharField(max_length=50)
    owner = models.ForeignKey(
        USER_MODEL,
        related_name="categories",
        on_delete=models.CASCADE,
    )

    def __str__(self):
        return self.name


class Account(models.Model):
    name = models.CharField(max_length=100)
    number = models.CharField(max_length=20)
    owner = models.ForeignKey(
        USER_MODEL,
        related_name="accounts",
        on_delete=models.CASCADE,
    )

    def __str__(self):
        return self.name

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.views import LoginView, LogoutView
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import login

# Create your views here.
class UserLogin(LoginView):
    template_name = "registration/login.html"


class UserLogout(LogoutView):
    template_name = "registration/logout.html"


def signup(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            username = request.POST.get("username")
            password = request.POST.get("password1")
            user = User.objects.create_user(
                username=username,
                password=password,
            )
            user.save()
            login(request, user)
            return redirect("home")
    else:
        form = UserCreationForm()
    context = {
        "form": form,
    }
    return render(request, "registration/signup.html", context)

receipts/views.py
from django.shortcuts import redirect, render
from django.urls import reverse_lazy
from django.views.generic import ListView, CreateView
from receipts.models import Account, ExpenseCategory, Receipt
from django.contrib.auth.mixins import LoginRequiredMixin

# Create your views here.


class ReceiptListView(LoginRequiredMixin, ListView):
    model = Receipt
    template_name = "receipts/list.html"
    context_object_name = "list_of_receipts"

    def get_queryset(self):
        return Receipt.objects.filter(purchaser=self.request.user)


class ReceiptCreateView(LoginRequiredMixin, CreateView):
    model = Receipt
    template_name = "receipts/create.html"
    fields = ["vendor", "total", "tax", "date", "category", "account"]

    def form_valid(self, form):
        item = form.save(commit=False)
        item.purchaser = self.request.user
        item.save()
        return redirect("home")


class ExpenseCategoryListView(LoginRequiredMixin, ListView):
    model = ExpenseCategory
    template_name = "category/list.html"

    def get_queryset(self):
        return ExpenseCategory.objects.filter(owner=self.request.user)


class ExpenseCategoryCreateView(LoginRequiredMixin, CreateView):
    model = ExpenseCategory
    template_name = "category/create.html"
    fields = ["name"]

    def form_valid(self, form):
        item = form.save(commit=False)
        item.owner = self.request.user
        item.save()
        return redirect("category_list")


class AccountCreateView(LoginRequiredMixin, CreateView):
    model = Account
    template_name = "account/create.html"
    fields = ["name", "number"]

    def form_valid(self, form):
        item = form.save(commit=False)
        item.owner = self.request.user
        item.save()
        return redirect("account_list")


class AccountListView(LoginRequiredMixin, ListView):
    model = Account
    template_name = "account/list.html"

    def get_queryset(self):
        return Account.objects.filter(owner=self.request.user)

receipts/templates/base.html
{% load static %}

<!DOCTYPE>
<html lang="eng">

<head>
    <title></title>
    <link rel="stylesheet" href="{% static 'css/nav.css' %}">
</head>
<body>
    <header>
        <nav>
            {% if user.is_authenticated %}
                <a href="{% url 'home' %}">Receipts</a>
                <a href="{% url 'create_receipt' %}">Create receipt</a>
                <a href="{% url 'account_list' %}">Account</a>
                <a href="{% url 'create_account' %}">Create Account</a>
                <a href="{% url 'category_list' %}">Categories</a>
                <a href="{% url 'create_category' %}">Create Category</a>
                <a href="{% url 'logout' %}">Logout</a>
            {% else %}            
                <a href="{% url 'login' %}">Login</a>
                <a href="{% url 'signup' %}">Sign Up</a>
            {% endif %}
        </nav>
    </header>
    <main>
        {% block content %}
        {% endblock content %}
    </main>
    <footer>
</body>
    </footer>

receipts/templates/category/create.html
{% extends 'base.html' %}

{% block content %}
    <main class="main">
        <h1>Create Expspense Category</h1>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div>
                <button>Create</button>
            </div>
        </form>
    </main>
{% endblock content %}

receipts/templates/category/list.html
{% extends 'base.html' %}


<head>
    <title>Categories</title>
</head>
{% block content %}
<body>
    <main class="main">
        <h1> Exspense Categories </h1>
        <table>
            <tr>
                <th>Name</th>
                <th>Number of Receipts</th>
            </tr>
            {% for x in expensecategory_list %}
            <tr>
                <td>{{ x.name }}</td>
                <td>{{ x.receipts.all|length }}</td>
            </tr>
            {% endfor %}
        </table>
    </main>
    <footer>

    </footer>
</body>
{% endblock content %}

receipts/templates/receipts/create.html
{% extends 'base.html' %}

{% block content %}
    <main class="main">
        <h1 class="center-text">Create a receipt</h1>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div>
                <button>Create</button>
            </div>
        </form>
    </main>
{% endblock content %}

receipts/templates/receipts/list.html
{% extends 'base.html' %}

<head>
    <title>Receipts</title>
</head>
{% block content %}
<body>
    <main class="main">
        <h1> Receipts: </h1>
        <table>
            <tr>
                <th>Vendor</th>
                <th>Total</th>
                <th>Tax</th>
                <th>Date</th>
                <th>Category</th>
                <th>Account</th>
            </tr>
            {% for x in list_of_receipts %}
            <tr>
                <td>{{ x.vendor }}</td>
                <td>{{ x.total }}</td>
                <td>{{ x.tax }}</td>
                <td>{{ x.date }}</td>
                <td>{{ x.category }}</td>
                <td>{{ x.account }}</td>
            </tr>
            {% endfor %}
        </table>
    </main>
    <footer>

    </footer>
</body>
{% endblock content %}